/*
Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description: 
*/


#ifndef __BMPANIMGUI_H
#define __BMPANIMGUI_H

#include <coeccntx.h>

#include <eikenv.h>
#include <eikappui.h>
#include <eikapp.h>
#include <eikdoc.h>
#include <eikmenup.h>
#include <eikstart.h> 
#include <math.h>

#include <bmpancli.h>
#include <eikon.hrh>

#include <bmpanimgui.rsg>
#include "BmpAnimGui.hrh"

const TInt KColorBallsMbmMaskIndex = 4;
const TInt KColorBallsMbmLastBallIndex = 3;
const TInt KColorBallsMbmFirstBallIndex = 0;
const TInt KColorBallsAnimFrameDelay = 150; // milliseconds
const TInt KColorBallsAnimXDeflectionIncrement = 20;
const TInt KColorBallsAnimXDeflectionStart = 0;
const TInt KColorBallsAnimXDeflectionTerminalValue = 600;
const TInt KColorBallsAnimYDeflectionOffset = 100;
const TInt KColorBallsAnimYDeflectionMultiplier = 50;


_LIT( KColorBallsMbmPath, "Z:\\resource\\apps\\BmpAnimGui\\ColorBalls.mbm"  );

// Application class
class CExampleApplication : public CEikApplication
	{
private:
	CApaDocument* CreateDocumentL();
	TUid AppDllUid() const;
	};

// View class
class CExampleAppView : public CCoeControl
    {
public:
	static CExampleAppView* NewL( const TRect& aRect );
	CExampleAppView();
	~CExampleAppView();
    	void ConstructL( const TRect& aRect );	

public:
	RBitmapAnim iBitmapAnimPlayer;

private:
	void Draw( const TRect& /*aRect*/ ) const;
	void LoadMbmL( const TDesC& aMbmFile );

private:
	HBufC*  iExampleText;
	CBitmapAnimClientData* iAnimFrames;
	RAnimDll iAnimDll;
	TInt iX;
	TInt iY;
    };

// Application UI class
class CExampleAppUi : public CEikAppUi
    {
public:
	void ConstructL();
	~CExampleAppUi();

private:
	void HandleCommandL(TInt aCommand);

private:
	CExampleAppView* iAppView;
	};

// Document class
class CExampleDocument : public CEikDocument
	{
public:
	static CExampleDocument* NewL(CEikApplication& aApp);
	CExampleDocument(CEikApplication& aApp);
	void ConstructL();
private:
	CEikAppUi* CreateAppUiL();
	};


#endif // __BMPANIMGUI_H

